//
//  TNAlbumsViewController.m
//  TableNavigation
//
//  Created by Justin Voss on 3/12/12.
//  Copyright (c) 2012 Bleeding Wolf Productions. All rights reserved.
//

#import "TNAlbumsViewController.h"

#import "TNSongsViewController.h"
#import "TNArtist.h"
#import "TNAlbum.h"

@interface TNAlbumsViewController ()

@end

@implementation TNAlbumsViewController

@synthesize tableView;
@synthesize artist;

- (id)initWithNibName:(NSString *)nibNameOrNil bundle:(NSBundle *)nibBundleOrNil
{
    self = [super initWithNibName:nibNameOrNil bundle:nibBundleOrNil];
    if (self) {
        // Custom initialization
    }
    return self;
}

- (void)viewDidLoad
{
    [super viewDidLoad];
    // Do any additional setup after loading the view from its nib.
}

- (void)viewDidUnload
{
    [self setTableView:nil];
    [super viewDidUnload];
    // Release any retained subviews of the main view.
    // e.g. self.myOutlet = nil;
}

- (BOOL)shouldAutorotateToInterfaceOrientation:(UIInterfaceOrientation)interfaceOrientation
{
    return (interfaceOrientation == UIInterfaceOrientationPortrait);
}

- (void)viewWillAppear:(BOOL)animated
{
    [super viewWillAppear:animated];
    
    self.title = self.artist.name;
}

- (void)viewDidAppear:(BOOL)animated
{
    [super viewDidAppear:animated];
    
    [self.tableView deselectRowAtIndexPath:[self.tableView indexPathForSelectedRow] animated:YES];
}

#pragma mark - Table View Methods

- (NSInteger)tableView:(UITableView *)tableView numberOfRowsInSection:(NSInteger)section
{
    return [self.artist.albums count];
}

- (UITableViewCell *)tableView:(UITableView *)tableView cellForRowAtIndexPath:(NSIndexPath *)indexPath
{
    static NSString *CellIdentifier = @"AlbumCell";
    UITableViewCell *cell = [self.tableView dequeueReusableCellWithIdentifier:CellIdentifier];
    if (cell == nil) {
        cell = [[UITableViewCell alloc] initWithStyle:UITableViewCellStyleSubtitle reuseIdentifier:CellIdentifier];
        cell.accessoryType = UITableViewCellAccessoryDisclosureIndicator;
    }
    
    TNAlbum *album = [self.artist.albums objectAtIndex:indexPath.row];
    cell.textLabel.text = album.title;
    cell.detailTextLabel.text = self.artist.name;
    
    return cell;
}

- (void)tableView:(UITableView *)tableView didSelectRowAtIndexPath:(NSIndexPath *)indexPath
{
    TNAlbum *album = [self.artist.albums objectAtIndex:indexPath.row];
    
    TNSongsViewController *songsViewController = [[TNSongsViewController alloc] init];
    songsViewController.album = album;
    
    [self.navigationController pushViewController:songsViewController animated:YES];
}

@end
