//
//  TNViewController.m
//  TableNavigation
//
//  Created by Justin Voss on 3/9/12.
//  Copyright (c) 2012 Bleeding Wolf Productions. All rights reserved.
//

#import "TNArtistsViewController.h"

#import "TNArtist.h"
#import "TNAlbumsViewController.h"

@interface TNArtistsViewController ()

@end

@implementation TNArtistsViewController

@synthesize tableView;
@synthesize artists;

- (void)viewDidLoad
{
    [super viewDidLoad];
    
	self.title = @"Artists";
}

- (void)viewDidUnload
{
    [self setTableView:nil];
    [super viewDidUnload];
    // Release any retained subviews of the main view.
}

- (BOOL)shouldAutorotateToInterfaceOrientation:(UIInterfaceOrientation)interfaceOrientation
{
    return (interfaceOrientation != UIInterfaceOrientationPortraitUpsideDown);
}

- (void)viewDidAppear:(BOOL)animated
{
    [super viewDidAppear:animated];
    
    [self.tableView deselectRowAtIndexPath:[self.tableView indexPathForSelectedRow] animated:YES];
}

- (NSInteger)tableView:(UITableView *)tableView numberOfRowsInSection:(NSInteger)section
{
    return [self.artists count];
}

- (UITableViewCell *)tableView:(UITableView *)tableView cellForRowAtIndexPath:(NSIndexPath *)indexPath
{
    static NSString *CellIdentifier = @"ArtistCell";
    UITableViewCell *cell = [self.tableView dequeueReusableCellWithIdentifier:CellIdentifier];
    if (cell == nil) {
        cell = [[UITableViewCell alloc] initWithStyle:UITableViewCellStyleDefault reuseIdentifier:CellIdentifier];
        cell.accessoryType = UITableViewCellAccessoryDisclosureIndicator;
    }
    
    TNArtist *artist = [self.artists objectAtIndex:indexPath.row];
    cell.textLabel.text = artist.name;
    
    return cell;
}

- (void)tableView:(UITableView *)tableView didSelectRowAtIndexPath:(NSIndexPath *)indexPath
{
    TNArtist *artist = [self.artists objectAtIndex:indexPath.row];
    
    TNAlbumsViewController *albumsViewController = [[TNAlbumsViewController alloc] init];
    albumsViewController.artist = artist;
    
    [self.navigationController pushViewController:albumsViewController animated:YES];
}

@end
